﻿using System.Linq;

namespace NMag.Core
{
    public class PowerPlantModule : Module
    {
        public PowerPlantModule(int number, string name, double maxDischarge, double energyEquivalent)
            : base(ModuleType.PowerPlant, number)
        {
            Units.Add(new PowerPlantUnit(this, name, maxDischarge, energyEquivalent));
        }

        private PowerPlantModule(PowerPlantModule module)
            : base(module)
        {
            if (module != null) { Units.Add(module.PowerPlant.Clone()); }
        }

        public PowerPlantUnit PowerPlant
        {
            get { return UnitHelper.GetPowerPlants(Units).FirstOrDefault(); }
        }

        public override Module Clone()
        {
            return new PowerPlantModule(this);
        }
    }
}
