﻿using System.Collections.Generic;

namespace NMag.Core
{
    public class PreferenceFunction
    {
        public PreferenceFunction() { }

        private PreferenceFunction(PreferenceFunction function)
        {
            Start = function.Start;
            End = function.End;

            SellingStart = function.SellingStart;
            RationingStart = function.RationingStart;

            PreferenceCurve = new PreferenceCurve(function.PreferenceCurve);
        }

        public int Start { get; set; } = 0;
        public int End { get; set; } = 0;

        public int SellingStart { get; set; } = 0;
        public int RationingStart { get; set; } = 0;

        public PreferenceCurve PreferenceCurve { get; set; } = new PreferenceCurve(new List<Point>());  // No code curve needed

        public PreferenceFunction Clone()
        {
            return new PreferenceFunction(this);
        }
    }
}
