﻿namespace NMag.Core
{
    public class TimeSeries
    {
        public TimeSeries() { }

        public TimeSeries(TimeSeries series)
        {
            SystemVar = series.SystemVar;
            ModuleNumber = series.ModuleNumber;
            ModuleVar = series.ModuleVar;
            FileName = series.FileName;
        }

        public enum SystemVariable
        {
            FirmPower = 1,
            Production = 2,
            ProdValue = 3
        }

        public enum ModuleVariable
        {
            LocalInflow = 1,
            TotalInflow = 2,
            ReservoirVolume = 3,
            ReservoirLevel = 4,
            Throughflow = 5,
            Bypass = 6,
            FloodSplill = 7,
            PowerProduction = 8
        }

        public SystemVariable SystemVar { get; set; }
        public int ModuleNumber { get; set; }
        public ModuleVariable ModuleVar { get; set; }
        public string FileName { get; set; }

        public TimeSeries Clone()
        {
            return new TimeSeries(this);
        }

        public override string ToString()
        {
            return string.Format("{0},{1},{2},{3},", ((int)SystemVar).ToString(),
                                                     ModuleNumber.ToString(),
                                                     ((int)ModuleVar).ToString(),
                                                     FileName);
        }
    }
}
