﻿using System.Collections.Generic;
using System.Windows;

namespace NMag.Core
{
    public class EnMagOperationalStrategy
    {
        public EnMagOperationalStrategy() { }

        private EnMagOperationalStrategy(EnMagOperationalStrategy strategy)
        {
            Strategy = strategy.Strategy;
            GuideCurve = new GuideCurve(strategy.GuideCurve);
            RationingRuleCurve = new RationingRuleCurve(strategy.RationingRuleCurve);
            SurplusRuleCurve = new SurplusRuleCurve(strategy.SurplusRuleCurve);
        }

        public enum OperationalStrategy
        {
            Unconditional = 300,
            GuideCurve = 500,
            RuleCurve = 600
        }

        public OperationalStrategy Strategy { get; set; }
        public GuideCurve GuideCurve { get; set; } = new GuideCurve(new List<Point>());                             // Curve code 500
        public RationingRuleCurve RationingRuleCurve { get; set; } = new RationingRuleCurve(new List<Point>());     // Curve code 600A
        public SurplusRuleCurve SurplusRuleCurve { get; set; } = new SurplusRuleCurve(new List<Point>());           // Curve code 600B

        public EnMagOperationalStrategy Clone()
        {
            return new EnMagOperationalStrategy(this);
        }
    }
}
