﻿using Newtonsoft.Json;
using System;
using System.IO;

namespace NMag.Core
{
    public class JSONHelper
    {
        public static void Serialize(object obj, string filePath)
        {
            JsonSerializer serializer = new JsonSerializer()
            {
                DefaultValueHandling = DefaultValueHandling.Ignore,
                ReferenceLoopHandling = ReferenceLoopHandling.Ignore
            };

            using (StreamWriter streamWriter = new StreamWriter(filePath))
            {
                using (JsonWriter writer = new JsonTextWriter(streamWriter))
                {
                    serializer.Serialize(writer, obj, obj.GetType());
                }
            }
        }

        public static object Deserialize(string fileName, Type objectType)
        {
            JsonSerializer serializer = new JsonSerializer();

            using (StreamReader streamReader = new StreamReader(fileName))
            {
                using (JsonReader reader = new JsonTextReader(streamReader))
                {
                    return serializer.Deserialize(reader, objectType);
                }
            }
        }
    }
}
