﻿using System.Collections.Generic;
using System.Linq;

namespace NMag.Core.Utilization
{
    public static partial class Util
    {
        public static System.Windows.Point Convert(this Point point)
        {
            return new System.Windows.Point(point.X, point.Y);
        }

        public static System.Windows.Point Add(this System.Windows.Point point1, System.Windows.Point point2)
        {
            return new System.Windows.Point(point1.X + point2.X, point1.Y + point2.Y);
        }

        public static System.Windows.Point Substract(this System.Windows.Point point1, System.Windows.Point point2)
        {
            return new System.Windows.Point(point1.X - point2.X, point1.Y - point2.Y);
        }

        public static double Interpolate(this List<Point> points, double x)
        {
            Point p0 = points.Where(p => p.X < x).LastOrDefault() ?? points.First();
            Point p1 = points.Where(p => p.X > x).FirstOrDefault() ?? points.Last();

            double dX = p1.X - p0.X;
            double dY = p1.Y - p0.Y;

            return (dY / dX) * (x - p0.X) + p0.Y;
        }
    }
}
