﻿using NMag.Core.Utilization;
using System.Windows;

namespace NMag.UI.Dialogs
{
    /// <summary>
    /// Interaction logic for NumberInputDialog.xaml
    /// </summary>
    public partial class NumberInputDialog : BaseDialog
    {
        public NumberInputDialog(string title, string description, int precision = 0, double value = 0)
        {
            InitializeComponent();

            Title = title;
            TextBox_Input.Precision = precision;
            Label_Description.Content = description;
            Result = value;
            TextBox_Input.Focus();
        }

        public double Result
        {
            get
            {
                if(TextBox_Input.Text.IsValidNumber())
                {
                    return double.Parse(TextBox_Input.Text);
                }

                return 0;
            }
            set
            {
                TextBox_Input.Text = value.ToString();
            }
        }

        private void Button_Ok_Click(object sender, RoutedEventArgs e)
        {
            On_Ok();
        }

        private void Button_Cancel_Click(object sender, RoutedEventArgs e)
        {
            On_Cancel();
        }
    }
}
