﻿using System;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Shapes;

namespace NMag.UI.FlowDiagram
{
    public abstract class ShapeBase : Shape
    {
        public ShapeBase(Guid unitID, Point position, MouseButtonEventHandler onModuleClickHandler)
        {
            UnitID = unitID;
            Position = position;

            MouseDown += onModuleClickHandler;
        }

        public Guid UnitID { get; set; }
        public Point Position { get; set; }

        public abstract Geometry Geometry { get; protected set; }

        protected override Geometry DefiningGeometry { get { return Geometry; } }

        protected abstract Geometry CreateGeometry(Point center, int width, int height);
    }
}
