﻿using System;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;

namespace NMag.UI.FlowDiagram
{
    public class ControlPointShape : ShapeBase
    {
        public ControlPointShape(Guid unitID, Point position,
            MouseButtonEventHandler onModuleClickHandler,
            int width, int height)
            : base(unitID, position, onModuleClickHandler)
        {
            Fill = Brushes.Green;
            Geometry = CreateGeometry(position, width, height);
        }

        public override Geometry Geometry { get; protected set; }

        protected override Geometry CreateGeometry(Point center, int width, int height)
        {
            return new EllipseGeometry(center, width / 2, height / 2);
        }
    }
}