﻿using System.Collections.Generic;
using System.Windows.Input;
using System.Windows.Media;
using System;
using NMag.Core.Utilization;
using System.Windows;

namespace NMag.UI.FlowDiagram
{
    public class ReservoirShape : ShapeBase
    {
        public ReservoirShape(Guid unitID, Point position,
            MouseButtonEventHandler onModuleClickHandler,
            int width, int height)
            : base(unitID, position, onModuleClickHandler)
        {
            Fill = Brushes.DodgerBlue;
            Geometry = CreateGeometry(position, width, height);
        }

        public override Geometry Geometry { get; protected set; }

        protected override Geometry CreateGeometry(Point center, int width, int height)
        {
            center = center.Add(new Point(-width / 2, -height / 2));

            Point a = center.Add(new Point(0, 0));
            Point b = center.Add(new Point(width, 0));
            Point c = center.Add(new Point(width/ 4 * 3, height));
            Point d = center.Add(new Point(width/ 4, height));

            List<PathSegment> segments = new List<PathSegment>()
            {
                new LineSegment(a, true),
                new LineSegment(b, true),
                new LineSegment(c, true),
                new LineSegment(d, true)
            };

            return new PathGeometry(new List<PathFigure>() { new PathFigure(a, segments, true) },
                FillRule.Nonzero,
                Transform.Identity);
        }
    }
}
