﻿using NMag.Core.Utilization;
using System;
using System.Collections.Generic;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;

namespace NMag.UI.FlowDiagram
{
    public class TransferShape : ShapeBase
    {
        public TransferShape(Guid unitID, Point position,
            MouseButtonEventHandler onModuleClickHandler,
            int width, int height)
            : base(unitID, position, onModuleClickHandler)
        {
            Fill = Brushes.Yellow;
            Geometry = CreateGeometry(position, width, height);
        }

        public override Geometry Geometry { get; protected set; }

        protected override Geometry CreateGeometry(Point center, int width, int height)
        {
            center = center.Add(new Point(-width / 2, -height / 2));

            List<Point> points = new List<Point>()
            {
                center.Add(new Point(0, height / 2)),
                center.Add(new Point(width / 6, 0)),
                center.Add(new Point(width * 5 / 6, 0)),
                center.Add(new Point(width, height / 2)),
                center.Add(new Point(width * 5 / 6, height)),
                center.Add(new Point(width / 6, height)),
            };

            List<PathSegment> segments = new List<PathSegment>();
            points.ForEach(point => segments.Add(new LineSegment(point, true)));

            return new PathGeometry(new List<PathFigure>() { new PathFigure(points[0], segments, true) },
                                    FillRule.Nonzero,
                                    Transform.Identity);
        }
    }
}