﻿using NMag.UI.Miscellaneous;
using System;

namespace NMag.UI
{
    public abstract class WindowViewModel : ObservableObject
    {
        public event EventHandler _requestCloseHandler;

        public abstract void Update();

        public WindowViewModel(EventHandler requestCloseHandler)
        {
            _requestCloseHandler = requestCloseHandler;
        }

        protected void Close()
        {
            if(_requestCloseHandler != null)
            {
                _requestCloseHandler.Invoke(this, new EventArgs());
            }
        }
    }
}
