﻿using NMag.UI.Miscellaneous;
using System.Windows.Input;

namespace NMag.UI.Views
{
    public class WaterSystemToolbarViewModel : ToolbarViewModel
    {
        public WaterSystemToolbarViewModel(MainViewModel mainViewModel) 
            : base(mainViewModel) { }

        public ICommand AddModuleCommand
        {
            get
            {
                return new RelayCommand(args => WaterSystem.AddModule(),
                    args => _mainViewModel.Application.Project != null);
            }
        }

        public ICommand RenameModuleCommand
        {
            get
            {
                return new RelayCommand(args => WaterSystem.RenameModule(),
                    args => _mainViewModel?.Application?.Project != null &&
                    WaterSystem.ModuleViewModel.IsModuleSelected);
            }
        }

        public ICommand DeleteModuleCommand
        {
            get
            {
                return new RelayCommand(args => WaterSystem.DeleteModule(),
                  args => _mainViewModel?.Application?.Project != null &&
                  WaterSystem.ModuleViewModel.IsModuleSelected);
            }
        }

        private WaterSystemViewModel WaterSystem
        {
            get { return _mainViewModel as WaterSystemViewModel; }
        }

        public override void Update()
        {

        }
    }
}
